%define version	5.5.2
%define release	%mkrel 8

%define major	0
%define libname	%mklibname %name %{major}
%define develname %mklibname %name -d
%define sdevelname %mklibname %name -d -s
%define bootstrap 0

Summary:	Library for doing number theory
Name:		ntl
Version:	%{version}
Release:	%{release}
URL:		http://www.shoup.net/ntl/index.html
Source0:	http://www.shoup.net/ntl/%{name}-%{version}.tar.gz
License:	GPLv2+
Group:		System/Libraries
BuildRequires:	gmp-devel

%if ! %bootstrap
BuildRequires:	gf2x-devel
%endif

BuildRequires:	libgmp-devel
BuildRequires:  libtool

Patch0:		ntl-5.5.2-sagemath.patch
Patch1:         %name-fix-libtool.patch

%description
NTL is a high-performance, portable C++ library providing data structures and
algorithms for manipulating signed, arbitrary length integers, and for vectors,
matrices, and polynomials over the integers and over finite fields.

%package -n %{libname}
Summary:        Main library for NTL (Number Theory Library)
Group:          System/Libraries
Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{_lib}ntl5 < %{version}-%{release}

%description -n %{libname}
This package contains the libraries needed to run programs dynamically linked
with NTL (Number Theory Library).

%package -n %{develname}
Group:		Development/C++
Summary:	Shared libraries and header files for NTL (Number Theory Library)
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
%if ! %bootstrap
Requires:	gf2x-devel
%endif
Obsoletes:	%mklibname -d ntl 5

%description -n %{develname}
This package contains the shared libraries and header files needed for
developing NTL (Number Theory Library) applications.

%prep
%setup -q
%patch0	-p1
%patch1 -p0

%build
%if %bootstrap
pushd src
./configure \
  CC="%{__cc}" \
  CXX="%{__cxx}" \
  CFLAGS="%{optflags} " \
  CXXFLAGS="%{optflags} -fPIC" \
  PREFIX=%{_prefix} \
  DOCDIR=%{_docdir} \
  INCLUDEDIR=%{_includedir} \
  LIBDIR=%{_libdir} \
  NTL_GMP_LIP=on \
  SHARED=on
popd

# not smp-safe
make -C src
%else
cd src

CFLAGS="`echo %optflags | sed 's/-O[0-9]/-O1/'`"
CXXFLAGS="`echo %optflags "-fno-rtti" | sed 's/-O[0-9]/-O1/'`"

./configure \
PREFIX=%{_prefix} \
        LIBDIR=$(echo %{_libdir} | sed 's,^%{_prefix},$${PREFIX},') \
        INCLUDEDIR=$(echo %{_includedir} | sed 's,^%{_prefix},$${PREFIX},') \
        DOCDIR=$(echo %{_docdir} | sed 's,^%{_prefix},$${PREFIX},') \
        NTL_GMP_LIP=on \
        NTL_STD_CXX=on \
        CC="${CC-gcc}" CXX="${CXX-g++}" \
        CPPFLAGS="$CPPFLAGS" \
        CFLAGS="$CFLAGS" \
        CXXFLAGS="$CXXFLAGS" \
        NTL_GF2X_LIB=on

LD_LIBRARY_PATH=. \
make \
        CPPFLAGS="$CPPFLAGS -DPIC" \
        CFLAGS="$CFLAGS -fPIC" \
        CXXFLAGS="$CXXFLAGS -fPIC" \
        AR='bash -e -c '\''out=$$1; lib=$$(basename $$out .a).so.%{major}; \
        lib=lib$${lib#lib}; set -x; rm -f $$lib; ${CXX} -shared -Wl,-soname,$$lib \
        -o "$$@" -lgmp -lgf2x; ln -s $$out $$lib'\' \
        RANLIB=: \
        all check

%endif

%install
cd src
make install \
  PREFIX=%{buildroot}%{_prefix} \
  DOCDIR=%{buildroot}%{_docdir} \
  INCLUDEDIR=%{buildroot}%{_includedir} \
  LIBDIR=%{buildroot}%{_libdir} 

%if %bootstrap
rm -f libntl.so.%{major}
mv -f .libs/libntl.a libntl.so.%{version}
ln -sf libntl.so.%{version} libntl.so.%{major}

make clean ntl.a check

# Unpackaged files
rm -rf %{buildroot}%{_docdir}/NTL
rm -f  %{buildroot}%{_libdir}/libntl.la
rm -f  %{buildroot}%{_libdir}/libntl.a

%else
install -m 755 libntl.so.* $RPM_BUILD_ROOT%{_libdir}/
ln -sf libntl.so.%{major} $RPM_BUILD_ROOT%{_libdir}/libntl.so
rm -f %{buildroot}%{_libdir}/*.a
%endif

rm -rf $RPM_BUILD_ROOT%{_defaultdocdir}/NTL

%files -n %{libname}
%doc README
%{_libdir}/*.so.%{major}

%files -n %{develname}
%doc doc/*
%{_includedir}/*
%{_libdir}/*.so


%changelog

* Thu Oct 18 2012 fwang <fwang> 5.5.2-8.mga3
+ Revision: 307845
- update file list
- update filelist
- cleanup spec

  + dmorgan <dmorgan>
    - Do not build in bootstrap anymore

* Tue Feb 01 2011 dmorgan <dmorgan> 5.5.2-7.mga1
+ Revision: 45745
- do not make devel package require gf2x-devel while in bootstrap mode

* Tue Feb 01 2011 dmorgan <dmorgan> 5.5.2-6.mga1
+ Revision: 45740
- Fix file list
- Fix build
- Fix libtool + install
- Add libtool as builrequire
  make bootstrap beautiful
- Build without gfx2 ( from fedora)
- Fix bootstrap build
- Add a bootstrap macros
- Remove mdv macros
- imported package ntl

